// funciones.h: declaracion de las funciones de esta DLL
// ------------------------------------------------------------------

#if !defined(_MODDLL_EXP_FUNCIONES_)
#define _MODDLL_EXP_FUNCIONES_

// Para poder exportar objetos MFC sin problemas
#undef AFX_DATA
#define AFX_DATA AFX_EXT_DATA

// ------------------------------------------------------------------
// Datos para imagen por defecto

#define IMG_X	4
#define IMG_Y	4
#define IMG_C	3
#define IMG_TAM IMG_X*IMG_Y*IMG_C

// ------------------------------------------------------------------
// Cabecera de una imagen

typedef struct STCabecera
{
	WORD wX;
	WORD wY;
	WORD wC;
	WORD wB;
} StCabecera;

// ------------------------------------------------------------------
// Funciones exportadas
// Estn reflejadas en el archivo .DEF del proyecto en el mismo orden
// ------------------------------------------------------------------

// Ejecuta las funciones de este mdulo
// iFunc		-> Funcion a realizar (0, 1, 2...)
// iNumCtr		-> Numero de controles o datos de configuracion
// iNumEnt		-> Numero de entradas
// iNumSal		-> Numero de salidas
// strTemp		-> Directorio donde estan las imagenes de entrada o salida
// pStrDatos	-> Array con los datos de configuracion, todos como cadenas de texto
// pStrImgEntr	-> Array con los nombres de las imagenes de entrada
// pStrImgSal	-> Array con los nombres de las imagenes de salida

int Ejecutar(int iFunc, int iNumCtr, int iNumEnt, int iNumSal, CString& strTemp, 
				CString* pStrDatos, CString* pStrImgEntr, CString* pStrImgSal);


// ------------------------------------------------------------------
// Funciones Privadas
// ------------------------------------------------------------------

// Leer imagen de entrada
BYTE* LeeImagenEntrada(CString& strNombre, StCabecera* pCab);

// Escribir imagenes resultado
int EscribeResultado(CString& strTemp, CString* pStrImgSal, int iTipo, 
					 BYTE* pHistoE, int iNumSal, int iNumCanales);

// Generar histograma en valor absoluto
long** GeneraHistograma(BYTE* pImg, WORD wTamX, WORD wTamY, WORD wCanales);

// Limbera memoria del histograma
void BorraHistograma(long** pHisto, WORD wCanales);

// Escalar histograma a un array de bytes en %
BYTE* EscalaByte(long** pHisto, WORD wNumCanales);

// Escalar histograma a un array de WORDs
BYTE* EscalaWord(long** pHisto, WORD wNumCanales);

// Escalar histograma a un array de DWORDs
BYTE* EscalaDWord(long** pHisto, WORD wNumCanales);

// Escalar histograma a un array de FLOATs
BYTE* EscalaFloat(long** pHisto, WORD wNumCanales);

// Escalar histograma a un array de Doubless
BYTE* EscalaDouble(long** pHisto, WORD wNumCanales);

// Borrar histograma escalado segun su tipo
void BorraHistoEsc(BYTE* pHistoE, WORD wCanales, int iTipo);


// ------------------------------------------------------------------

#undef AFX_DATA
#define AFX_DATA

#endif // _MODDLL_EXP_FUNCIONES_
